*************************************************************************
*                                                                       *
* 12/5/93 MX-11 Multitasking Executive for MICRO-C/11 V 2.0             *
*                                                                       *
* Equates and structure definitions                                     *
*                                                                       *
* Kevin J White, kevin@novell.com                                       *
*                                                                       *
* Copyright 1993 Kevin White.  All rights reserved.                     *
*                                                                       *              *
*************************************************************************
* Configuration Constants
TCBSIZE  equ     32
ECBSIZE  equ     6
*********************************************************************
* Misc Constants
FALSE    equ     0
TRUE     equ     1
NULL     equ     0      
nullstk  equ     64            nulltask stack space
STKMRGN  equ     13            space for interrupt + parm and temp
MXSTKSIG equ     $A5           bottom of stack signature
*********************************************************************
* Timer constants
OC1I     equ     $80           value to enable OC1 interrupt
OC1F     equ     $80           value to reset timer interrupt
TM1CNT   equ     50000         compare value for real time clock (40Hz)
TOCK     equ     2             number of ticks per tock
TOCKFREQ equ     20            number of ticks per second
*********************************************************************
*
*       TCB Data Structure
*
tlink    equ     0             link to next TCB
tstat    equ     2             Task status
tpri     equ     3             Task priority
tsp      equ     4             Current Stackpointer
tstart   equ     6             Starting address
tspinit  equ     8             Initial stackpointer
tqhead   equ     10            Head of message queue
tqtail   equ     12            Tail of message queue
tsema    equ     14            Address of current semaphore or event flag
tsemalnk equ     16            Link to next TCB in semaphore or eflag chain
tsemrlnk equ     18            Link to previous TCB in semaphore chain
tname    equ     20            pointer to name of task
tspend   equ     22            bottom of stack space
tspmin   equ     24            lowest stack encountered
ttimer   equ     26            Timer
tmask    equ     28            event flag mask
treturn  equ     30            timeout flag
*        
*       Status Values
*        
tready   equ     0             Task ready to run or running
tsleep   equ     1             task waiting on timer
trcv     equ     2             task waiting to receive message
tdormant equ     3             Task dormant but ok to run
tisractv equ     4             Active ISR
tisrdorm equ     5             Dormant ISR
*
* The following need unlinking from a task list when they timeout
*
tswait   equ   $80             waiting on semaphore
tefwait  equ   $81             Task waiting on event flag
*
*       Message Structure
*
mlink    equ     0             message link
mtask    equ     2             sending task
message  equ     4             actual message or pointer

*       Poll List Structure
plink    equ     0
ptask    equ     2               TCB of task to poll
pmesg    equ     4               event to send
*
*        Semaphore structure
*
semhead  equ     0             Link to first TCB waiting on semaphore
semtail  equ     2             Link to last TCB waiting on semaphore
semsema  equ     4             two byte semaphore
*
*        Event flag structure (identical to semaphore except for names)
*
efhead   equ     0             Link to first TCB waiting on event flag
eftail   equ     2             Link to last TCB waiting on event flag
efvalue  equ     4             two byte eventflag
*********************************************************************
* Error Codes
SCIerr   equ     1
semerr   equ     2
semerr1  equ     3
swcherr  equ     4
*********************************************************************
